---
apiVersion: batch/v1
kind: Job
metadata:
  name: "{{ .Release.Name }}-{{ .Chart.Name }}"
  labels:
    app.kubernetes.io/managed-by: {{ .Release.Service | quote }}
    app.kubernetes.io/instance: {{ .Release.Name | quote }}
    app.kubernetes.io/version: {{ .Chart.AppVersion | quote }}
    helm.sh/chart: {{ .Release.Service | quote }}
  annotations:
    "helm.sh/hook": pre-install,pre-upgrade
    "helm.sh/hook-weight": "5"
    "helm.sh/hook-delete-policy": hook-succeeded
spec:
  template:
    metadata:
      name: "{{ .Release.Name }}-{{ .Chart.Name }}"
      labels:
        app.kubernetes.io/managed-by: {{ .Release.Service | quote }}
        app.kubernetes.io/instance: {{ .Release.Name | quote}}
        helm.sh/chart: {{ .Release.Service | quote }}
    spec:
      containers:
      - name: vault-cron-job
        image: curlimages/curl
        env:
          {{- $newrbac := merge .Values.injectRabcEnv .Values.extraEnv }}
          {{- range $key, $value := $newrbac  | default nil }}
          - name: {{ $key }}
            value: {{ tpl (quote $value) $ }}
          {{- end }}
        resources:
          limits:
            cpu: "1"
            memory: "300Mi"
          requests:
            cpu: "1"
            memory: "300Mi"
        args:
        - /bin/sh
        - -c
        - "curl --header  'X-Vault-Token: {{ .Values.global.vault_token}}' --request POST --data ' {\"db.username\": \"{{ .Values.global.db_username}}\", \"db.password\": \"{{ .Values.global.db_password}}\", \"db.url\": \"{{ .Values.global.db_url}}\", \"minio.access.key\": \"{{ .Values.global.minio_access_key}}\", \"minio.secret.key\": \"{{ .Values.global.minio_secrt_key}}\", \"minio.url\": \"{{ .Values.global.minio_url}}\", \"image.secret.enc\": \"{{ .Values.global.image_secret_enc }}\", \"image.secret.dec\": \"{{ .Values.global.image_secret_dec }}\", \"security-auth-server-url\": \"https://{{ tpl .Values.global.pssecurity_url . }}\", \"security-realm\": \"{{ .Values.global.security_realm }}\", \"security-secret\": \"{{ .Values.global.security_client_secret }}\", \"security-client\": \"{{ .Values.global.security_client }}\"} ' --insecure {{ .Values.global.vault_url}}/v1/{{ .Values.global.vault_secret_eng}}/{{ .Release.Name }}"
      restartPolicy: Never                                                                                                                 
  # successfulJobsHistoryLimit: 3
  # failedJobsHistoryLimit: 3

